const gs = require('gradient-string');
const spinnies = require('dreidels');
const chalk = require('chalk');

module.exports = async app => {
    app.cache = {
        users: {},
        series: {},
        seriesCount: 0
    };

    return new Promise(async resolve => {
        const loaders = [];
        const spin = new spinnies();

        let userCache = spin.add("ar", {text: "Caching Users..."});
        loaders.push(require('./cache/users')(app, userCache));

        let seriesCache = spin.add("ar", {text: "Caching Series..."});
        loaders.push(require('./cache/series')(app, seriesCache));

        await Promise.all(loaders);
        console.log('');
        resolve(0);
    });
}; //robbery is cool :)